﻿-- Author      : Nogarder
-- Create Date : 2012/12/11 13:41:06
local NPA_Color_GetColorByFaction=NPA.Color.GetColorByFaction
local NPA_Color_GetColorByClass=NPA.Color.GetColorByClass
local NPA_Color_GetColorByThreat=NPA.Color.GetColorByThreat
local NPA_NamePlateDataParser_AddElements=NPA.NamePlateDataParser.AddElements

local NPA_NamePlateModuleManager_ZipModule=NPA.NamePlateModuleManager.ZipModule
local NPA_NamePlateModuleManager_UnzipModule=NPA.NamePlateModuleManager.UnzipModule

NPA.NamePlateModuleManager.RegisterDataModule("Text","Name",function(framedata,textframe,setting)
	--add event elements
 	--hook name update
	NPA_NamePlateDataParser_AddElements(framedata,textframe,"Name_Updated",function(framedata,unitdata)
		textframe.Text:SetText(unitdata.Name)
		NPA_NamePlateModuleManager_UnzipModule(textframe)
	end)
	--color mode
	local colormode=setting.ColorMode
	if(colormode==1)then --color by faction
		--hook faction update
		NPA_NamePlateDataParser_AddElements(framedata,textframe,"Type_Updated",function(framedata,unitdata)
			local color=NPA_Color_GetColorByFaction(unitdata.Faction)
			textframe.Text:SetTextColor(color.R,color.G,color.B,color.A)
		end)
	elseif(colormode==2)then --color by class
		--hook class update
		NPA_NamePlateDataParser_AddElements(framedata,textframe,"Type_Updated",function(framedata,unitdata)
			local color=NPA_Color_GetColorByClass(unitdata.Class,unitdata.Type)
			textframe.Text:SetTextColor(color.R,color.G,color.B,color.A)
		end)
	elseif(colormode==3)then --color by threat
		--hook threat update
		NPA_NamePlateDataParser_AddElements(framedata,textframe,"Threat_Updated",function(framedata,unitdata)
			local color=NPA_Color_GetColorByThreat(unitdata.ThreatStatus)
			textframe.Text:SetTextColor(color.R,color.G,color.B,color.A)
		end)
	elseif(colormode==4 and framedata.Default)then
		NPA_NamePlateDataParser_AddElements(framedata,textframe,"ModuleMain_OnUpdate",function(framedata,unitdata)
			textframe.Text:SetTextColor(framedata.Default.NameText:GetTextColor())
		end)
	end
end)